// 	LISTA SIMPLEMENTE VINCULADA en Programacin Estructurada

#include <iostream.h>
#include <stdlib.h>

struct Nodo {         		//  Un nodo mnimo, su estructura
	int info;
	Nodo *prox;
	Nodo(int x=0,Nodo *p=NULL) {info=x; prox=p;} //  Su constructor
};

struct Lista  {       		//  Los datos de la lista,
	Nodo *raiz,*q;     	//  reunidos en una estructura, con
	Lista (){raiz=q=0;}  	//  su respectivo constructor
};

//    Funciones de tratamiento de Nodo

int   getInfo(Nodo *p){return p->info;} 		   //  Obtenemos info
Nodo *getProx(Nodo *p){return p->prox;}      	//  Obtenemos prox
void  setInfo(int x,Nodo *p){p->info=x;}     	//  Asignamos info
void  setProx(Nodo *p,Lista lista){lista.q->prox=p;} //  Asignamos prox

//    Prototipos de tratamiento de Lista

int  vacia(Lista lista){return lista.raiz == 0 ? 1 : 0;}
void borrLista(Lista lista);						//  Destructor
void insUltimo (int x,Lista &lista);			//  Al fondo
void insPrimero(int x,Lista &lista); 			//  Al principio
Nodo *loBorramos(int x,Lista &lista);			//  Excluir nodo
Nodo *loEncuentro(int x,Lista &lista);			//  Busqueda
void imprimir(Lista lista);

/* El parmetro lista se pasa por referencia para posibilitar
	que en main() podamos tratar varias listas simultaneamente. */

//  Funciones de tratamiento de Lista

void borrLista(Lista &lista) {     // Destructor de lista
	Nodo *p=lista.raiz;
	while (p){
		lista.raiz=p;
		p=getProx(p);
		delete lista.raiz;
	}
};

void insPrimero(int x,Lista &lista) {  // Insercin al inicio
	Nodo *p;
	p = new Nodo(x,lista.raiz); //  Insertamos ...
	lista.raiz = p;             //  Redireccionamos raiz ...
};

void insUltimo(int x,Lista &lista) {   // Insercin al fin
	if (vacia(lista))
		lista.raiz = new Nodo(x);
	else {
		Nodo *p;
		for(p=lista.raiz;p;lista.q=p,p=getProx(lista.q));
		setProx(new Nodo(x),lista);
	}
};

Nodo* loBorramos(int x,Lista &lista) {  // Borrado de nodo especfico
	Nodo *p=loEncuentro(x, lista);
	if (p) {            //  Encontrado
		setProx (getProx(p),lista); //  "Bypass" al nodo p ...
		delete p;       //  y lo borramos ...
		return lista.q; // Direccin del nodo previo al borrado 
	}
	else
		return NULL;
};

Nodo* loEncuentro(int x,Lista &lista) {
	for(Nodo *p=lista.raiz; p && getInfo(p)!= x; lista.q=p,p=getProx(p));
		return p !=  NULL ? p : NULL;
};

void imprimir(Lista lista){
	for(Nodo *p=lista.raiz;p;p=getProx(p))
		cout <<getInfo(p)<<",  ";
	cout <<" \n";
};

void main(void) {
	int frente[]={1,2,3};
	int fondon[]={7,8,9};
	int i;
	Lista lista;   //  Var. estruct. list c/atributos raiz=q= 0
	cout <<"Lista vinculada simple, en Prg. Estr. \n";
	cout <<"===================================== \n\n";
	for(i=0;i< sizeof(frente)/2;i++)
		insPrimero(frente[i],lista);
	cout <<"Lista con {frente} \n";
	imprimir(lista);
	for(i=0;i< sizeof(fondon)/2;i++)
		insUltimo(fondon[i],lista);
	cout <<"Lista con {frente} y {fondon} \n";
	imprimir(lista);
	if(loBorramos(7,lista)){
		cout<<"loBorramos(7), lista queda: \n";
		imprimir(lista);
	}
	else{
		cout<<"no loBorramos(7), lista queda: \n";
		imprimir(lista);
	}
	cout <<"Terminamos ... \n";
	exit(1);
}
